# This file is a template, and might need editing before it works on your project.
# use docker image with latex preinstalled
# since there is no official latex image, use https://github.com/blang/latex-docker
# possible alternative: https://github.com/natlownes/docker-latex

stages:
  - build
  - pages
  - deploy
  - accessibility

build:
  image: vincentxavier/latex
  stage: build
  script:
    - sh @src/generate-gitinfo.sh
    - python3 @src/compile.py

  artifacts:
    paths:
      - "*.pdf"
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      changes:
        - LaTeX/*

.pages_template: &pages_template
  stage: build
  image: node:current-slim
  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
    BASE_URL: "/informatique/terminale-nsi"
  cache:
    paths:
      - .cache/pip
      - _build/
  before_script:
    - apt update
    - apt install --no-install-recommends -y graphviz tree python3-venv git
    - python3 -m venv .venv
    - source .venv/bin/activate
    - pip install -U pip
  script:
    - pip install -r requirements.txt
    - jupyter book build --html
    - mv _build/html public
  artifacts:
    paths:
      - public
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    - if: '$CI_PIPELINE_SOURCE == "web"'

pages:
  <<: *pages_template

pages_merge_request_build:
  <<: *pages_template
  environment:
    name: review-docs/$CI_MERGE_REQUEST_ID
    url: "https://$CI_PROJECT_ROOT_NAMESPACE.$CI_PAGES_DOMAIN/-/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/-/jobs/$CI_JOB_ID/artifacts/public/index.html"

    on_stop: pages_merge_request_stop
    auto_stop_in: 2 weeks
  rules:
    - if: $CI_MERGE_REQUEST_ID

pages_merge_request_stop:
  script: echo "stop pages review"
  stage: build
  environment:
    name: review-docs/$CI_MERGE_REQUEST_ID
    action: stop
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: manual

